﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace WindowsGame3
{
    class Enemy:Game
    {
        Texture2D texture;
        Rectangle[] rectangles = new Rectangle[10];
        Rectangle cutout;
        Random random = new Random(13213);
        int index;


        public Enemy(GameEngine ge)
            : base(ge)
        {
            for (int i = 0; i < rectangles.Length; i++)
            {
                rectangles[i] = new Rectangle(random.Next(1000), random.Next(1000)-1000, 40, 55);
            }
        }

        public override void LoadContent(ContentManager content)
        {
            base.LoadContent(content);
            texture = content.Load<Texture2D>("enemy");
        }

        public override void Update(KeyboardState input)
        {
            base.Update(input);


            for (int i = 0; i < rectangles.Length; i++)
            {
                if (rectangles[i].Y < 500)
                {
                    
                    if (integral < 100)
                    {
                        rectangles[i].Y += 2;
                    }
                    if (integral > 100)
                    {
                        rectangles[i].Y += 3;
                    }
                    if (integral > 500)
                    {
                        rectangles[i].Y += 4;
                    }
                    if (integral > 1000)
                    {
                        rectangles[i].Y += 5;
                    }
                }
                else
                {
                    
                    rectangles[i].Y = 0;
                }

                if (i == random.Next(1, 10))
                {
                    EnemyBullet.Location = new Point(rectangles[i].X, rectangles[i].Y);
                }


                for (int j = 0; j < Bullet.Rectanlges.Length; j++)
                {
                    if (Bullet.Rectanlges[j].X > rectangles[i].X && Bullet.Rectanlges[j].X < rectangles[i].X + 40 && Bullet.Rectanlges[j].Y < rectangles[i].Y)
                    {
                        rectangles[i].Y = -100;
                        integral += 2;
                    }
                }
                if (Spirit.SpiritLocation.X + 20 > rectangles[i].X && Spirit.SpiritLocation.X + 20 < rectangles[i].X + 32 && Spirit.SpiritLocation.Y < rectangles[i].Y )
                {
                    Spirit.SpiritLocation = new Point(400, 500);
                    dieCount += 1;
                }
            }

            index = index < 3 ? index : 0;
            cutout = new Rectangle(index * 40, 0, 40, 55);
            index++;

        }

        public override void Draw(SpriteBatch spritebatch)
        {
            base.Draw(spritebatch);

            for (int i = 0; i < rectangles.Length; i++)
            {
                spritebatch.Draw(texture, rectangles[i], cutout, Color.AliceBlue);
            }

        }
    }
}
